- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions

# MFnVectorArrayData Class Reference

# OpenMaya - API module for common classes | FunctionSet classes

Search for all occurrences

## Detailed Description

int array function set for dependency node data.

MFnVectorArrayData allows the creation and manipulation of MVectorArray data objects for use in the dependency graph.

If a user written dependency node either accepts or produces MVectorArrays, then this class is used to extract or create the data that comes from or goes to other dependency graph nodes. The MDataHandle::type method will return kVectorArray when data of this type is present. To access it, the MDataHandle::data method is used to get an MObject for the data and this should then be used to initialize an instance of MFnVectorArrayData.

Examples:

  dynExprField.cpp, ownerEmitter.cpp, particleAttrNode.cpp, simpleFluidEmitter.cpp, and torusField.cpp.

`#include <MFnVectorArrayData.h>`

Inheritance diagram for MFnVectorArrayData:
[legend]

List of all members.

## Public Member Functions
virtual MFn::Type | type () const
| Function set type.
virtual | ~MFnVectorArrayData ()
| Destructor.
| MFnVectorArrayData ()
| Default constructor.
| MFnVectorArrayData (MObject &object, MStatus *ReturnStatus=NULL)
| Constructor.
unsigned int | length (MStatus *ReturnStatus=NULL) const
| Return the number of vectors in the instance.
MStatus | set (MVector &element, unsigned int index)
| Set the element at the specified index.
MStatus | copyTo (MVectorArray &) const
| Copy all the vectors in the instance into the given MVectorArray.
MStatus | set (const MVectorArray &newArray)
| Set the instance to contain the vectors defined in the given MVectorArray.
MVectorArray | array (MStatus *ReturnStatus=NULL)
| Return an MVectorArray containing the vector array currently operated upon by the function set.
MObject | create (MStatus *ReturnStatus=NULL)
| Create a new MObject, attach it to this instance, and initialize it to be empty.
MObject | create (const MVectorArray &in, MStatus *ReturnStatus=NULL)
| Create a new MObject, attach it to this instance, and initialize it to contain the data from the given MVectorArray.
| MFnVectorArrayData (const MObject &object, MStatus *ReturnStatus=NULL)
| Constructor.
const MVector & | operator[] (unsigned int index) const
| NO SCRIPT SUPPORT.
MVector & | operator[] (unsigned int index)
| NO SCRIPT SUPPORT.
## Protected Member Functions
virtual const char * | className () const
| Class name.

## Constructor & Destructor Documentation

MFnVectorArrayData | ( | MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

MFnVectorArrayData | ( | const MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

## Member Function Documentation

MFn::Type type | ( |  | ) | const `[virtual]`

Search for all occurrences

Function set type.

Return the class type : MFn::kVectorArrayData.

Reimplemented from MFnData.

const char * className | ( |  | ) | const `[protected, virtual]`

Search for all occurrences

Class name.

Return the class name : "MFnVectorArrayData".

Reimplemented from MFnData.

unsigned int length | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Return the number of vectors in the instance.

Parameters:

  [out] | ReturnStatus | kFailure if the instance is not attached to an MObject, and kSuccess otherwise.

Returns:
  The number of vectors in the instance

MStatus set | ( | MVector & | element,
|  | unsigned int | index
| ) |  |

Search for all occurrences

Set the element at the specified index.

No checking is done by this class to ensure that the index is valid - use the length method to determine the size of the array.

Parameters:

  [in] | element | the element
  [in] | index | the index of the vector to set

Returns:
  - kSuccess operation successful
  - kFailure instance is not attached to an MObject

Examples:
  particleAttrNode.cpp.

MStatus copyTo | ( | MVectorArray & | dest | ) | const

Search for all occurrences

Copy all the vectors in the instance into the given MVectorArray.

Parameters:

  [out] | dest | the MVectorArray to populate

Returns:
  - kSuccess operation successful
  - kFailure instance is not attached to an MObject

MStatus set | ( | const MVectorArray & | array | ) |

Search for all occurrences

Set the instance to contain the vectors defined in the given MVectorArray.

Parameters:

  [in] | array | the MVectorArray containing the data to set into this instance

Returns:
  - kSuccess operation successful
  - kFailure instance is not attached to an MObject

MVectorArray array | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Return an MVectorArray containing the vector array currently operated upon by the function set.

The MVectorArray returned by this method is editable, so any changes to the return instance also affects the MObject operated upon by this function set.

Parameters:

  [out] | ReturnStatus | kFailure if the instance is not attached to an MObject, and kSuccess otherwise.

Returns:
  A copy of the MVectorArray held in this instance

Examples:
  particleAttrNode.cpp.

MObject create | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Create a new MObject, attach it to this instance, and initialize it to be empty.

Parameters:

  [out] | ReturnStatus | kSuccess

Returns:
  The newly created MObject

Examples:
  dynExprField.cpp, particleAttrNode.cpp, and torusField.cpp.

MObject create | ( | const MVectorArray & | arr,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Create a new MObject, attach it to this instance, and initialize it to contain the data from the given MVectorArray.

Parameters:

  [in] | arr | the data to use when initializing this instance
  [out] | ReturnStatus | kSuccess

Returns:
  The newly created MObject

const MVector & operator[] | ( | unsigned int | index | ) | const

NO SCRIPT SUPPORT.

Extract the indicated int from the const instance.

No checking is done by this class to ensure that the index is valid - use the length method to determine the size of the array. If the instance is not attached to an MObject, this method will return an empty vector.

Parameters:

  [in] | index | the index of the vector to extract

Returns:
  The indicated vector

MVector & operator[] | ( | unsigned int | index | ) |

NO SCRIPT SUPPORT.

Extract the indicated vector from the instance.

by the function set. The vector returned by this method is editable, so any changes to the returned instance also affects the MObject operated upon by this function set.

No checking is done by this class to ensure that the index is valid - use the length method to determine the size of the array. If the instance is not attached to an MObject, this method will return a zero vector.

Parameters:

  [in] | index | the index of the vector to extract

Returns:
  The indicated vector

MFnVectorArrayData MFnVectorArrayData MFnVectorArrayData MFnVectorArrayData MFnVectorArrayData MFnVectorArrayData MFnVectorArrayData MFnVectorArrayData MFnVectorArrayData MFnVectorArrayData
MFnVectorArrayData MFnVectorArrayData MFnVectorArrayData MFnVectorArrayData MFnVectorArrayData MFnVectorArrayData MFnVectorArrayData MFnVectorArrayData MFnVectorArrayData MFnVectorArrayData